/*
 * (C) Copyright 2017-2018, by Dimitrios Michail and Contributors.
 *
 * JGraphT : a free Java graph-theory library
 *
 * This program and the accompanying materials are dual-licensed under
 * either
 *
 * (a) the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation, or (at your option) any
 * later version.
 *
 * or (per the licensee's choosing)
 *
 * (b) the terms of the Eclipse Public License v1.0 as published by
 * the Eclipse Foundation.
 */
package org.integratedmodelling.contrib.jgrapht.alg.interfaces;

import java.util.*;

/**
 * A maximal clique enumeration algorithm.
 * 
 * @param <V> the graph vertex type
 * @param <E> the graph edge type
 * 
 * @author Dimitrios Michail
 */
public interface MaximalCliqueEnumerationAlgorithm<V, E>
    extends
    Iterable<Set<V>>
{

    /**
     * Returns an iterator over all maximal cliques.
     *
     * @return an iterator over all maximal cliques
     */
    @Override
    Iterator<Set<V>> iterator();

}
